<template>
  <div class="add-user fixed inset-0">
    <div class="h-full flex items-center justify-center">
      <div id="addUser" class="add-user__content xs:w-full bg-bgdsec p-8 xs:px-4 xs:pt-4 rounded-32">
        <div class="flex items-center justify-between">
          <p class="text-txtdprim font-bold text-2xl leading-7 xs:text-lg xs:leading-6">Add Super User</p>
          <UiButton button-height="sm" color-type="secondary" class="w-12 rounded-16" @click="closeAddUser">
            <img width="24" height="24" src="@/assets/images/ui/ui-cross.svg" />
          </UiButton>
        </div>
        <div class="mt-8 flex gap-2 items-center">
          <p class="text-txtdsec font-medium">Public Address</p>
        </div>
        <UiInput v-model="publicAddress" class="mt-4 rounded-16" />
        <UiButton :disabled="!publicAddress" class="w-full rounded-24 mt-8" @click="addUser">
          <span v-if="!loading">Add Super User</span>
          <LoadingSpinner color-type="white" v-else />
        </UiButton>
      </div>
    </div>
  </div>
</template>

<script>
import { addSuperUser } from '@/api/admin';

import UiInput from '@/components/ui/UiInput.vue';
import LoadingSpinner from '@/components/ui/LoadingSpinner.vue';
import UiButton from '@/components/ui/UiButton.vue';

export default {
  name: 'AddUser',

  components: { UiButton, UiInput, LoadingSpinner },

  data() {
    return {
      publicAddress: '',

      loading: false,
    };
  },

  methods: {
    closeAddUser() {
      this.$emit('close');
    },

    async addUser() {
      this.loading = true;

      try {
        await addSuperUser(this.publicAddress);
        this.closeAddUser();
        this.$store.dispatch('setPopupDisplay', {
          display: true,
          text: 'User successfully added.',
        });

        this.$emit('update-users');
        this.publicAddress = '';
      } catch (err) {
        console.error(err);
        if (err.response.status === 422) {
          this.$store.dispatch('setPopupDisplay', {
            display: true,
            text: 'User already exists.',
            status: 'error',
          });
          return;
        }
        this.$store.dispatch('setPopupDisplay', {
          display: true,
          text: 'User not found.',
          status: 'error',
        });
      } finally {
        this.loading = false;
      }
    },
  },
};
</script>

<style lang="scss">
.add-user {
  background: rgba(12, 21, 33, 0.64);

  &__content {
    width: 500px;
  }
}
</style>
